    PROGRAM MAIN
    USE OMP_LIB
    IMPLICIT NONE
      include 'mpif.h'
      INTEGER :: IERR,MYID,NPROCS
      INTEGER :: STATUS
      CHARACTER(128) :: HNAME
      INTEGER(4) :: HOSTNM

      INTEGER,PARAMETER :: NLP=100
      INTEGER :: I,TMAX,TID

      CALL MPI_INIT(IERR)
      CALL MPI_COMM_SIZE(MPI_COMM_WORLD,NPROCS,IERR)
      CALL MPI_COMM_RANK(MPI_COMM_WORLD,MYID,IERR)

      STATUS = HOSTNM(HNAME)
      IF (MYID==0) WRITE(*,'("NUMBER OF PROCESSES: ",I3)') NPROCS

      TMAX = OMP_GET_MAX_THREADS()
      WRITE(*,'("MAXIMUM NUMBER OF THREADS: ",I2)') TMAX

!$OMP PARALLEL PRIVATE(TID)
      TID = OMP_GET_THREAD_NUM()
!$OMP DO
      DO I=1,NLP
          WRITE(*,'("HELLO WORLD! (HOST NAME: ",A10,", MYID: ",I3,", TID: ",I2,", I: ",I5,")")') HNAME,MYID,TID,I
      END DO
!$OMP END DO
!$OMP END PARALLEL 

      CALL MPI_FINALIZE(IERR)

    END PROGRAM MAIN
